%define api 5
%define major 5
%define oname qt5

%define module qtdeclarative

%define qtqml %mklibname qt%{api}qml %{major}
%define qtqmld %mklibname qt%{api}qml -d
%define qtquick %mklibname qt%{api}quick %{major}
%define qtquickd %mklibname qt%{api}quick -d
%define qtquickparticles %mklibname qt%{api}quickparticles %{major}
%define qtquickparticlesd %mklibname qt%{api}quickparticles -d
%define qtquicktest %mklibname qt%{api}quicktest %{major}
%define qtquicktestd %mklibname qt%{api}quicktest -d
%define qtquickwidgets %mklibname qt%{api}quickwidgets %{major}
%define qtquickwidgetsd %mklibname qt%{api}quickwidgets -d

# Requires qdoc5 and qt5-tools to build
%bcond_with docs

Summary:	Version 5 of the Qt toolkit (%{module} packages)
Name:		qt5-%{module}
Version:	5.6.1
Release:	2
License:	LGPLv3+
Group:		Development/KDE and Qt
Url:		http://qt-project.org/
Source0:	http://ftp.fau.de/qtproject/official_releases/qt/%(echo %{version} |cut -d. -f1-2)/%{version}/submodules/%{module}-opensource-src-%{version}.tar.xz
Source100:	%{name}.rpmlintrc
# Patches from Fedora package
Patch100:	0007-Revert-Remove-this-piece-of-code.patch
Patch101:	0010-Fix-crash-for-unknown-QQmlListModel-roles-in-debug-b.patch
Patch102:	0011-Avoid-Canvas-crashes-with-qtquickcompiler.patch
Patch103:	0016-Fix-crash-with-SignalTransition.patch
Patch104:	0024-Revert-removal-of-Fixed-MouseArea-threshold-with-pre.patch
Patch105:	0027-Fix-crash-when-using-with-statement-with-an-expressi.patch
Patch106:	0033-QML-Only-release-types-if-they-aren-t-referenced-any.patch
Patch107:	Check-for-NULL-from-glGetString.patch
Patch108:	qtdeclarative-kdebug346118.patch
Patch109:	qtdeclarative-QQuickShaderEffectSource_deadlock.patch
BuildRequires:	pkgconfig(Qt5Core) >= %{version}
BuildRequires:	pkgconfig(Qt5DBus) >= %{version}
BuildRequires:	pkgconfig(Qt5Gui) >= %{version}
BuildRequires:	pkgconfig(Qt5Network) >= %{version}
BuildRequires:	pkgconfig(Qt5PrintSupport) >= %{version}
BuildRequires:	pkgconfig(Qt5Sql) >= %{version}
BuildRequires:	pkgconfig(Qt5Test) >= %{version}
BuildRequires:	pkgconfig(Qt5Widgets) >= %{version}
BuildRequires:	pkgconfig(Qt5Xml) >= %{version}
BuildRequires:	pkgconfig(Qt5XmlPatterns) >= %{version}
%if %{with docs}
BuildRequires:	qdoc5
BuildRequires:	qt5-tools
%endif

%description
Version 5 of the Qt toolkit (%{module} packages).

#----------------------------------------------------------------------------

%package -n %{qtqml}
Summary:	QML runtime support library
Group:		System/Libraries
Suggests:	qt5-qtcanvas3d-qml
Suggests:	qt5-qtgraphicaleffects-qml
Suggests:	qt5-qtquickcontrols-qml
Suggests:	qt5-qtquickcontrols2-qml
Suggests:	qt5-qtdeclarative-i18n
Conflicts:	%{_lib}qt5declarative5 < 5.6.0
Conflicts:	%{_lib}qt5quick5 < 5.6.0-6

%description -n %{qtqml}
QML runtime support library.

%files -n %{qtqml}
%{_qt5_libdir}/libQt%{api}Qml.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Qml.so.%{major}*
%endif
%dir %{_qt5_prefix}/qml
%dir %{_qt5_prefix}/qml/Qt
%dir %{_qt5_prefix}/qml/Qt/labs
%{_qt5_prefix}/qml/Qt/labs/folderlistmodel
%{_qt5_prefix}/qml/Qt/labs/settings/
%{_qt5_prefix}/qml/QtQml
%{_qt5_plugindir}/qmltooling/libqmldbg_debugger.so
%{_qt5_plugindir}/qmltooling/libqmldbg_inspector.so
%{_qt5_plugindir}/qmltooling/libqmldbg_local.so
%{_qt5_plugindir}/qmltooling/libqmldbg_native.so
%{_qt5_plugindir}/qmltooling/libqmldbg_profiler.so
%{_qt5_plugindir}/qmltooling/libqmldbg_server.so
%{_qt5_plugindir}/qmltooling/libqmldbg_tcp.so

#----------------------------------------------------------------------------

%package -n %{qtqmld}
Summary:	Development files for the Qt QML library
Group:		Development/KDE and Qt
Requires:	%{qtqml} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtqmld}
Development files for the Qt QML library.

%files -n %{qtqmld}
%{_qt5_includedir}/QtQml
%{_qt5_includedir}/QtQmlDevTools
%{_qt5_libdir}/libQt%{api}Qml.so
%{_qt5_libdir}/libQt%{api}Qml.prl
%{_qt5_libdir}/libQt%{api}QmlDevTools.a
%{_qt5_libdir}/libQt%{api}QmlDevTools.prl
%{_qt5_libdir}/cmake/Qt%{api}Qml
%{_qt5_libdir}/pkgconfig/Qt%{api}Qml.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Qml.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_qml.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_qml_private.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_qmldevtools_private.pri

#----------------------------------------------------------------------------

%package -n %{qtquick}
Summary:	Runtime library for Qt Quick
Group:		System/Libraries
Conflicts:	%{_lib}qt5declarative5 < 5.6.0

%description -n %{qtquick}
Runtime library for Qt Quick.

%files -n %{qtquick}
%{_qt5_libdir}/libQt%{api}Quick.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Quick.so.%{major}*
%endif
%{_qt5_prefix}/qml/builtins.qmltypes
%{_qt5_prefix}/qml/QtQuick.2
%{_qt5_prefix}/qml/QtQuick

#----------------------------------------------------------------------------

%package -n %{qtquickd}
Summary:	Development files for Qt Quick
Group:		Development/KDE and Qt
Requires:	%{qtquick} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtquickd}
Development files for Qt Quick.

%files -n %{qtquickd}
%{_qt5_includedir}/QtQuick
%{_qt5_libdir}/libQt%{api}Quick.so
%{_qt5_libdir}/libQt%{api}Quick.prl
%{_qt5_libdir}/cmake/Qt%{api}Quick
%{_qt5_libdir}/pkgconfig/Qt%{api}Quick.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Quick.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_quick.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_quick_private.pri

#----------------------------------------------------------------------------

%package -n %{qtquickparticles}
Summary:	Runtime library for Qt Quick's particle engine
Group:		System/Libraries

%description -n %{qtquickparticles}
Runtime library for Qt Quick's particle engine.

%files -n %{qtquickparticles}
%{_qt5_libdir}/libQt%{api}QuickParticles.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}QuickParticles.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtquickparticlesd}
Summary:	Development files for Qt Quick's particle engine
Group:		Development/KDE and Qt
Requires:	%{qtquickparticles} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtquickparticlesd}
Development files for Qt Quick's particle engine.

%files -n %{qtquickparticlesd}
%{_qt5_includedir}/QtQuickParticles
%{_qt5_libdir}/libQt%{api}QuickParticles.so
%{_qt5_libdir}/libQt%{api}QuickParticles.prl
%{_qt5_prefix}/mkspecs/modules/qt_lib_quickparticles_private.pri

#----------------------------------------------------------------------------

%package -n %{qtquicktest}
Summary:	Qt Quick unit test module
Group:		System/Libraries
Conflicts:	%{_lib}qt5test5 < 5.6.0

%description -n %{qtquicktest}
Qt Quick unit test module.

%files -n %{qtquicktest}
%{_qt5_libdir}/libQt%{api}QuickTest.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}QuickTest.so.%{major}*
%endif
%{_qt5_prefix}/qml/QtTest

#----------------------------------------------------------------------------

%package -n %{qtquicktestd}
Summary:	Development files for Qt Quick's unit test module
Group:		Development/KDE and Qt
Requires:	%{qtquicktest} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtquicktestd}
Development files for Qt Quick's unit test module.

%files -n %{qtquicktestd}
%{_qt5_includedir}/QtQuickTest
%{_qt5_libdir}/libQt%{api}QuickTest.so
%{_qt5_libdir}/libQt%{api}QuickTest.prl
%{_qt5_libdir}/cmake/Qt%{api}QuickTest
%{_qt5_libdir}/pkgconfig/Qt%{api}QuickTest.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}QuickTest.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_qmltest.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_qmltest_private.pri

#----------------------------------------------------------------------------

%package -n %{qtquickwidgets}
Summary:	Library for integrating QtQuick with traditional Qt widgets
Group:		System/Libraries

%description -n %{qtquickwidgets}
Library for integrating QtQuick with traditional Qt widgets

%files -n %{qtquickwidgets}
%{_qt5_libdir}/libQt%{api}QuickWidgets.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}QuickWidgets.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtquickwidgetsd}
Summary:	Development files for version 5 of the QtQuickWidgets library
Group:		Development/KDE and Qt
Requires:	%{qtquickwidgets} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0

%description -n %{qtquickwidgetsd}
Development files for version 5 of the QtQuickWidgets library.

%files -n %{qtquickwidgetsd}
%{_qt5_includedir}/QtQuickWidgets
%{_qt5_libdir}/libQt%{api}QuickWidgets.so
%{_qt5_libdir}/libQt%{api}QuickWidgets.prl
%{_qt5_libdir}/cmake/Qt%{api}QuickWidgets
%{_qt5_libdir}/pkgconfig/Qt%{api}QuickWidgets.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}QuickWidgets.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_quickwidgets.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_quickwidgets_private.pri

#----------------------------------------------------------------------------

%package -n %{oname}-qml-tools
Summary:	QML tools for Qt 5
Group:		Development/KDE and Qt

%description -n %{oname}-qml-tools
QML tools for Qt 5.

%files -n %{oname}-qml-tools
%{_qt5_bindir}/qml
%{_qt5_bindir}/qmleasing
%{_qt5_bindir}/qmlimportscanner
%{_qt5_bindir}/qmllint
%{_qt5_bindir}/qmlmin
%{_qt5_bindir}/qmlplugindump
%{_qt5_bindir}/qmlprofiler
%{_qt5_bindir}/qmlscene
%{_qt5_bindir}/qmltestrunner

#----------------------------------------------------------------------------

%package examples
Summary:	Example applications for %{name}
Group:		Development/KDE and Qt
Conflicts:	qt5-examples < 5.6.0

%description examples
Example applications for %{name}.

%files examples
%{_qt5_exampledir}/qml/
%{_qt5_exampledir}/qmltest/
%{_qt5_exampledir}/quick/

#----------------------------------------------------------------------------

%prep
%setup -qn %{module}-opensource-src-%{version}
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p0
%patch109 -p1

%build
%qmake_qt5
%make STRIP=true

%if %{with docs}
%make docs
%endif

%install
make install STRIP=true INSTALL_ROOT=%{buildroot}

%if %{with docs}
make install_qch_docs INSTALL_ROOT=%{buildroot}
%endif

%if "%{_qt5_libdir}" != "%{_libdir}"
pushd %{buildroot}%{_libdir}
ln -s ../%{_lib}/qt%{api}/%{_lib}/*.so.* .
mkdir pkgconfig
cd pkgconfig
ln -s ../../%{_lib}/qt%{api}/%{_lib}/pkgconfig/*.pc .
popd
%endif

# Workaround for
# *** ERROR: same build ID in nonidentical files!
#        /usr/lib/qt5/bin/qdbuscpp2xml
#   and  /usr/lib/qt5/bin/moc
# ...
# while generating debug info
find %{buildroot} -type f -perm -0755 |grep -vE '\.(so|qml|sh|pl|ttf|eot|woff)' |xargs %__strip --strip-unneeded

# QMAKE_PRL_BUILD_DIR = /builddir/build/BUILD/qt-everywhere-opensource-src-5.4.0-beta/qtwayland/src/client
## .prl/.la file love
# nuke .prl reference(s) to %%buildroot, excessive (.la-like) libs
pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd

%changelog

* Wed Jun 22 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 5.6.1-2
- (4786045) Add various bugfix patches from Fedora (including patch for QTBUG-53761)


